
#pragma once


// ArmarX
#include <ArmarXCore/core/Component.h>
#include <ArmarXCore/interface/observers/ObserverInterface.h>
#include <ArmarXCore/util/tasks.h>
#include <ArmarXGui/libraries/ArmarXGuiComponentPlugins/LightweightRemoteGuiComponentPlugin.h>

// RobotAPI
#include <RobotAPI/interface/armem/server/MemoryInterface.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>
#include <RobotAPI/libraries/armem/client/ComponentPlugin.h>
#include <RobotAPI/libraries/armem/core/workingmemory/Memory.h>

#include <RobotAPI/libraries/armem_objects/client/articulated_object/Writer.h>

namespace armarx::articulated_object
{

    /**
     * @defgroup Component-ExampleClient ExampleClient
     * @ingroup RobotAPI-Components
     * A description of the component ExampleClient.
     *
     * @class ExampleClient
     * @ingroup Component-ExampleClient
     * @brief Brief description of class ExampleClient.
     *
     * Detailed description of class ExampleClient.
     */
    class ArticulatedObjectExampleMemoryWriterClient :
        virtual public armarx::Component
        // virtual public armarx::armem::client::WriterComponentPluginUser
    {
    public:
        ArticulatedObjectExampleMemoryWriterClient();

        /// @see armarx::ManagedIceObject::getDefaultName()
        std::string getDefaultName() const override;

    protected:

        armarx::PropertyDefinitionsPtr createPropertyDefinitions() override;

        void onInitComponent() override;
        void onConnectComponent() override;
        void onDisconnectComponent() override;
        void onExitComponent() override;

        void run();


    private:

        armarx::RunningTask<ArticulatedObjectExampleMemoryWriterClient>::pointer_type task;

        armarx::DebugObserverInterfacePrx debugObserver;

        std::unique_ptr<::armarx::armem::articulated_object::Writer> articulatedObjectWriter;

    };

}  // namespace armarx::articulated_object
