#pragma once



namespace armarx::armem::base::detail
{
    class MaxHistorySize
    {
    public:

        virtual ~MaxHistorySize();

        /**
         * @brief Sets the maximum history size of entities in this segment.
         * This affects all current entities as well as new ones.
         * @see Entity::setMaxHistorySize()
         */
        virtual void setMaxHistorySize(long maxSize);
        virtual long getMaxHistorySize() const;


    protected:

        /**
         * @brief Maximum size of entity histories.
         *
         * If negative, the size of `history` is not limited.
         *
         * @see Entity::maxHstorySize
         */
        long _maxHistorySize = -1;

    };
}
