#pragma once

#include <ArmarXCore/interface/core/Profiler.h>
#include <ArmarXCore/observers/ObserverObjectFactories.h>

#include <RobotAPI/libraries/armem_skills/aron/Statechart.aron.generated.h>

namespace armarx::armem
{
    std::map<armarx::eStateType, armarx::armem::arondto::Statechart::StateType> toAronStateTypeMap =
    {
        {eNormalState, armarx::armem::arondto::Statechart::StateType::NORMAL},
        {eFinalState, armarx::armem::arondto::Statechart::StateType::FINAL},
        {eRemoteState, armarx::armem::arondto::Statechart::StateType::REMOTE},
        {eDynamicRemoteState, armarx::armem::arondto::Statechart::StateType::DYNAMIC_REMOTE},
        {eUndefined, armarx::armem::arondto::Statechart::StateType::UNDEFINED},
    };

    std::map<armarx::armem::arondto::Statechart::StateType, armarx::eStateType> fromAronStateTypeMap =
    {
        {armarx::armem::arondto::Statechart::StateType::NORMAL, eNormalState},
        {armarx::armem::arondto::Statechart::StateType::FINAL, eFinalState},
        {armarx::armem::arondto::Statechart::StateType::REMOTE, eRemoteState},
        {armarx::armem::arondto::Statechart::StateType::DYNAMIC_REMOTE, eDynamicRemoteState},
        {armarx::armem::arondto::Statechart::StateType::UNDEFINED, eUndefined},
    };

    void fromAron(const armarx::armem::arondto::Statechart::StateType& dto, armarx::eStateType& bo);
    void toAron(armarx::armem::arondto::Statechart::StateType& dto, const armarx::eStateType& bo);

    void fromAron(const armarx::armem::arondto::Statechart::ParameterMap& dto, armarx::StateParameterMap& bo);
    void toAron(armarx::armem::arondto::Statechart::ParameterMap& dto, const armarx::StateParameterMap& bo);

    void fromAron(const armarx::armem::arondto::Statechart::Transition& dto, armarx::ProfilerStatechartTransitionWithParameters& bo);
    void toAron(armarx::armem::arondto::Statechart::Transition& dto, const armarx::ProfilerStatechartTransitionWithParameters& bo);
}
